package u8;

import java.util.ArrayList;

public class Rectangle {
    private int x;
    private int y;
	private int width;
    private int height;
    
    public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}

	public int getWidth() {
		return width;
	}

	public int getHeight() {
		return height;
	}

	public Rectangle( int x, int y, int width, int height ) {
         this.x = x;
         this.y = y;
         this.width = width;
         this.height = height;
    }

    public Rectangle() {
       this( 0, 0, 10, 10 );
    }

    public int perimeter() {
         return 2*(width + height);
    }

    public int area() {
         return (width * height);
    }

    public void set( int x, int y, int width, int height ) {
    	if (x>=0 && y>=0 && width>0 && height>0){
    		  this.x = x;
    		  this.y = y;
    		  this.width = width;
    		  this.height = height;
    	}      
    }

    public boolean identical( Rectangle r ) {
         return (this.x==r.x)&&(this.y==r.y)&&
                (this.width==r.width)&&(this.height==r.height);
    }

    public boolean equal( Rectangle r ) {
         return (this.width==r.width)&&(this.height==r.height);
    }

    public boolean overlaps( Rectangle r ) {
         return  !(( r.x > this.x + this.width )  ||
                  ( this.x > r.x + r.width )     ||
                  ( r.y > this.y + this.height ) ||
                  ( this.y > r.y + r.height ));     
    }
    
    public boolean contains( Rectangle r){
    	return x<=r.x && (x+width)>=(r.x+r.width) && y<=r.y && (y+height)>=(r.y+r.width);
    }
    
    public Rectangle clone(){
    	return new Rectangle(this.x, this.y, this.width, this.height);
    }
    
    public ArrayList <Rectangle> sumOfSquares(){
    	ArrayList <Rectangle> squares = new ArrayList<Rectangle>();
    	Rectangle temp = (Rectangle) this.clone();
    	
    	while (temp.height!=temp.width){
    		if (temp.width>temp.height){
    			squares.add(new Rectangle(temp.x, temp.y, temp.height, temp.height ));
    			temp.width = temp.width-temp.height;
    			temp.x = temp.x+temp.height;
    		}else{
    			squares.add(new Rectangle(temp.x, temp.y, temp.width, temp.width ));
    			temp.height = temp.height-temp.width;
    			temp.y = temp.y + temp.width;
    		}
    	}
    	squares.add(temp);
    	return squares;
    }

} // end of class Rectangle
