package u8;

/**
* ALP 2 - Team - Homework 8
* @version 1.0
*/

public class Root3Num {
	
	/* We can calculate the root of 3 only one time and store the value on a class variable.
	 * All objects can use this for calculations 
	 */
	final static double root3 = Math.sqrt(3); 
	final static Root3Num zero = new Root3Num(0,0);
 
	/* Because the root3num-Objects suppose to be immutable that means we cannot change the 
	 * object's state after construction, we declare both attributes as final.
	 */
	private final int a; 
	private final int b;
	
	/* Constructor */
	public Root3Num(){
		this.a = 0;
		this.b = 0;
	}
	
	/* Constructor */
	public Root3Num(int a, int b){
		this.a = a;
		this.b = b;
	}
	
	/* returns a new Root3Num-object whose value is equal (this + x) */
	public Root3Num add( Root3Num x ){
		return new Root3Num(this.a + x.a, this.b + x.b);			
	}
	
	/* returns a new Root3Num-object with the value (this - x) */
	public Root3Num sub(Root3Num x){
		return new Root3Num(this.a - x.a, this.b - x.b);		
	}
	
	/* calculate (this * x) and returns the result as a RooT3Num object */
	public Root3Num mult(Root3Num x){
		int newA = this.a * x.a + this.b * x.b*2;
		int newB = this.a * x.b + this.b * x.a;
		return new Root3Num(newA, newB);		
	}
	
	/* returns a new Root3Num-object whose value is (n * this) */ 
	public Root3Num times(int n){
		return new Root3Num(n*this.a, n*this.b);
	}

	/* calculate the real value of the invoking object (this) */
	public double value(){
		return a + b*root3;
	}
	
	/* compare of the real value of the invoking object is smaller than the value of x */
	public boolean lt(Root3Num x){
		return this.value()<x.value();
	}
	
	/* compare of the real value of the invoking object is bigger than the value of x */
	public boolean gt(Root3Num x){
		return this.value()>x.value();
	}
	
	public boolean equal(Root3Num x){
		return !(lt(x) || gt(x));
 	}
	
	/* returns a string representation of the invoking object (this) */
	public String toString(){
		return this.a+"+"+this.b+"*sqrt(3)  ";
	}
	
	public void print(){
		System.out.print(this.toString());
	}
	
	public void println(){
		System.out.print(this.toString()+"\n");
	}
	
	public void printValue(){
		System.out.print(this.value()+" ");
	}
	
	/* this class method returns a new Roor3Num-object whose value is (x + y) */
	public static Root3Num add(Root3Num x, Root3Num y){
		return new Root3Num(y.a + x.a, y.b + x.b);
	}
	
	/* this class method returns a new Roor3Num-object whose value is (x - y) */
	public static Root3Num sub(Root3Num x, Root3Num y){
		return new Root3Num(x.a - y.a, x.b - y.b);
	}
	
	/* returns a new Root3Num-object whose value is (x * y) */
	public static Root3Num mult(Root3Num x, Root3Num y){
		return x.mult(y);		
	}
	
	/* returns a new Root3Num-object whose value is (n * x) */
	public static Root3Num times(int n, Root3Num x){
		return new Root3Num(n*x.a, n*x.b);
	}

} // end of class Root3Num
