package u8;

/**
* ALP 2 - Team - Homework 8
* @version 1.0
*/

public class TestRoot3Num {
	
	public static Root3Num[][] nullMatrix(int m, int n){
		Root3Num[][] zeros = new Root3Num[m][n];
		for(int i=0; i<m; i++){
			for(int j=0; j<n; j++){
				zeros[i][j] = Root3Num.zero;
			}
		}
		return zeros;
	}
	
	public static Root3Num[][] matrixMult(Root3Num[][] a, Root3Num[][] b){
		assert a!=null && b!=null;
		int rows = a.length;
		int n = a[0].length;
		int m = b.length;
		int cols = b[0].length;		
		Root3Num[][] result = null;
		
		/* we check if the dimensions of the matrices are suitable for multiplication */
		if ( n == m ) {
			 result = nullMatrix(rows, cols); /* create a matrix with zeros */		 			 
			 for(int i=0; i<rows; i++){
				 for(int j=0; j<cols; j++ ){
					 for( int k=0; k<n; k++){
						 result[i][j] = Root3Num.add(result[i][j], Root3Num.mult(a[i][k], b[k][j]));
					 }
				 }
			 }
		}
		return result;
	}
	
	/* only Root3Num-Operations (integer arithmetic) is used in this method */
	public static Root3Num onlyRoot3NumOps(int iters){		
		Root3Num z1, z2;
		Root3Num z3 = new Root3Num(1,1);
		
		for (int i=0; i<iters; i++){
			z2 = new Root3Num(-1,i);
			z1 = new Root3Num(1,-i);
			z3 = z3.add(z1.add(z2));
		}
		return z3;
	}
	
	/* this are the same calculations as in onlyRoot3NumOps but with double numbers */
	public static double calculateRootsFirst(int iters){
		double z1, z2;
		double z3 = new Root3Num(1,1).value();
		
		for (int i=0; i<iters; i++){
			z2 = new Root3Num(-1,i).value();
			z1 = new Root3Num(1,-i).value();
			z3 = z3 + z1 + z2;
		}
		return z3;
	}
	
	public static double absDiff(double d1, double d2){
		return Math.abs(d1-d2);
	}
	
	public static void printRoot3NumMatrix(Root3Num[][] matrix){
		for(int i=0; i<matrix.length; i++){
			for(int j=0; j<matrix[0].length; j++){
				matrix[i][j].print();
			}
			System.out.println();
		}
		System.out.println();
	}
	
	public static void printRoot3NumMatrixValues(Root3Num[][] matrix){
		for(int i=0; i<matrix.length; i++){
			for(int j=0; j<matrix[0].length; j++){
				matrix[i][j].printValue();
			}
			System.out.println();
		}
		System.out.println();
	}
	
	public static void main(String[] args){	
		
		Root3Num a10 = new Root3Num(1,0);
		Root3Num a00 = new Root3Num(0,0);
		Root3Num a01 = new Root3Num(0,1);
		
		Root3Num identity[][] = {
				{a10,a00,a00},
				{a00,a10,a00},
				{a00,a00,a10}
		};
		
		Root3Num b11 = new Root3Num(1,1);
		Root3Num b12 = new Root3Num(1,2);
		Root3Num b13 = new Root3Num(1,3);
		Root3Num b21 = new Root3Num(2,1);
		Root3Num b22 = new Root3Num(2,2);
		Root3Num b23 = new Root3Num(2,3);
		Root3Num b31 = new Root3Num(3,1);
		Root3Num b32 = new Root3Num(3,2);
		Root3Num b33 = new Root3Num(3,3);
		
		Root3Num b[][] = {
				{b11,b12,b13},
				{b21,b22,b23},
				{b31,b32,b33}
		};
		
		System.out.println("I");
		printRoot3NumMatrix(identity);
		
		System.out.println("B");
		printRoot3NumMatrix(b);
		
		System.out.println("I (values)");	
		printRoot3NumMatrixValues(identity);
		
		System.out.println("B (values)");
		printRoot3NumMatrixValues(b);
		
		Root3Num[][] r = TestRoot3Num.matrixMult(identity,b);
		
		System.out.println("I*B");
		printRoot3NumMatrix(r);
		
		System.out.println("Test to show the benefits of the Root3Num class ");			
		for (int i=1; i<100000000; i=i*10){
			Root3Num result = onlyRoot3NumOps(i); /* calculations only with integer arithmetic */
			double d1 = result.value();			  /* at the end calculate only one root-term */
			double d2 = calculateRootsFirst(i);   /* calculate the root-terms at the beginning of the calculations */
			System.out.println(d1+"  "+d2);
			System.out.println("rounding error with "+ i + " iterations: "+ absDiff(d1,d2)+"\n");
		}
	}

}// end of TestRoot3Num class
